<?php
/**
 * FirewallReadFirewallRead
 *
 * PHP version 7.4
 *
 * @category Class
 * @package  SLIS\Adapter\Hub
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * slis hub
 *
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 0.7.4
 * Contact: dev@slis.io
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 6.1.0-SNAPSHOT
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace SLIS\Adapter\Hub\Model;

use \ArrayAccess;
use \SLIS\Adapter\Hub\ObjectSerializer;

/**
 * FirewallReadFirewallRead Class Doc Comment
 *
 * @category Class
 * @package  SLIS\Adapter\Hub
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 * @implements \ArrayAccess<string, mixed>
 */
class FirewallReadFirewallRead implements ModelInterface, ArrayAccess, \JsonSerializable
{
    public const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'Firewall-read_firewall.read';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'serviceLevelAgreement' => '\SLIS\Adapter\Hub\Model\ServiceLevelAgreementReadFirewallRead',
        'uuid' => 'string',
        'name' => 'string',
        'ip' => 'string',
        'mac' => 'string',
        'typ' => '\SLIS\Adapter\Hub\Model\GeraetTypReadFirewallRead',
        'beschreibung' => 'string',
        'seriennummer' => 'string',
        'version' => 'string',
        'externalIdentifier' => 'string',
        'netzwerk' => '\SLIS\Adapter\Hub\Model\FirewallReadFirewallReadNetzwerk',
        'hersteller' => '\SLIS\Adapter\Hub\Model\FirewallReadFirewallReadHersteller',
        'tags' => '\SLIS\Adapter\Hub\Model\TagReadFirewallRead[]',
        'status' => '\SLIS\Adapter\Hub\Model\StatusReadFirewallRead',
        'created' => '\DateTime',
        'updated' => '\DateTime'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      * @phpstan-var array<string, string|null>
      * @psalm-var array<string, string|null>
      */
    protected static $openAPIFormats = [
        'serviceLevelAgreement' => null,
        'uuid' => null,
        'name' => null,
        'ip' => null,
        'mac' => null,
        'typ' => null,
        'beschreibung' => null,
        'seriennummer' => null,
        'version' => null,
        'externalIdentifier' => null,
        'netzwerk' => null,
        'hersteller' => null,
        'tags' => null,
        'status' => null,
        'created' => 'date-time',
        'updated' => 'date-time'
    ];

    /**
      * Array of nullable properties. Used for (de)serialization
      *
      * @var boolean[]
      */
    protected static array $openAPINullables = [
        'serviceLevelAgreement' => false,
		'uuid' => false,
		'name' => false,
		'ip' => true,
		'mac' => true,
		'typ' => false,
		'beschreibung' => true,
		'seriennummer' => true,
		'version' => true,
		'externalIdentifier' => true,
		'netzwerk' => true,
		'hersteller' => true,
		'tags' => false,
		'status' => false,
		'created' => true,
		'updated' => true
    ];

    /**
      * If a nullable field gets set to null, insert it here
      *
      * @var boolean[]
      */
    protected array $openAPINullablesSetToNull = [];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

    /**
     * Array of nullable properties
     *
     * @return array
     */
    protected static function openAPINullables(): array
    {
        return self::$openAPINullables;
    }

    /**
     * Array of nullable field names deliberately set to null
     *
     * @return boolean[]
     */
    private function getOpenAPINullablesSetToNull(): array
    {
        return $this->openAPINullablesSetToNull;
    }

    /**
     * Checks if a property is nullable
     *
     * @param string $property
     * @return bool
     */
    public static function isNullable(string $property): bool
    {
        return self::openAPINullables()[$property] ?? false;
    }

    /**
     * Checks if a nullable property is set to null.
     *
     * @param string $property
     * @return bool
     */
    public function isNullableSetToNull(string $property): bool
    {
        return in_array($property, $this->getOpenAPINullablesSetToNull(), true);
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'serviceLevelAgreement' => 'serviceLevelAgreement',
        'uuid' => 'uuid',
        'name' => 'name',
        'ip' => 'ip',
        'mac' => 'mac',
        'typ' => 'typ',
        'beschreibung' => 'beschreibung',
        'seriennummer' => 'seriennummer',
        'version' => 'version',
        'externalIdentifier' => 'externalIdentifier',
        'netzwerk' => 'netzwerk',
        'hersteller' => 'hersteller',
        'tags' => 'tags',
        'status' => 'status',
        'created' => 'created',
        'updated' => 'updated'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'serviceLevelAgreement' => 'setServiceLevelAgreement',
        'uuid' => 'setUuid',
        'name' => 'setName',
        'ip' => 'setIp',
        'mac' => 'setMac',
        'typ' => 'setTyp',
        'beschreibung' => 'setBeschreibung',
        'seriennummer' => 'setSeriennummer',
        'version' => 'setVersion',
        'externalIdentifier' => 'setExternalIdentifier',
        'netzwerk' => 'setNetzwerk',
        'hersteller' => 'setHersteller',
        'tags' => 'setTags',
        'status' => 'setStatus',
        'created' => 'setCreated',
        'updated' => 'setUpdated'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'serviceLevelAgreement' => 'getServiceLevelAgreement',
        'uuid' => 'getUuid',
        'name' => 'getName',
        'ip' => 'getIp',
        'mac' => 'getMac',
        'typ' => 'getTyp',
        'beschreibung' => 'getBeschreibung',
        'seriennummer' => 'getSeriennummer',
        'version' => 'getVersion',
        'externalIdentifier' => 'getExternalIdentifier',
        'netzwerk' => 'getNetzwerk',
        'hersteller' => 'getHersteller',
        'tags' => 'getTags',
        'status' => 'getStatus',
        'created' => 'getCreated',
        'updated' => 'getUpdated'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }


    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->setIfExists('serviceLevelAgreement', $data ?? [], null);
        $this->setIfExists('uuid', $data ?? [], null);
        $this->setIfExists('name', $data ?? [], null);
        $this->setIfExists('ip', $data ?? [], null);
        $this->setIfExists('mac', $data ?? [], null);
        $this->setIfExists('typ', $data ?? [], null);
        $this->setIfExists('beschreibung', $data ?? [], null);
        $this->setIfExists('seriennummer', $data ?? [], null);
        $this->setIfExists('version', $data ?? [], null);
        $this->setIfExists('externalIdentifier', $data ?? [], null);
        $this->setIfExists('netzwerk', $data ?? [], null);
        $this->setIfExists('hersteller', $data ?? [], null);
        $this->setIfExists('tags', $data ?? [], null);
        $this->setIfExists('status', $data ?? [], null);
        $this->setIfExists('created', $data ?? [], null);
        $this->setIfExists('updated', $data ?? [], null);
    }

    /**
    * Sets $this->container[$variableName] to the given data or to the given default Value; if $variableName
    * is nullable and its value is set to null in the $fields array, then mark it as "set to null" in the
    * $this->openAPINullablesSetToNull array
    *
    * @param string $variableName
    * @param array  $fields
    * @param mixed  $defaultValue
    */
    private function setIfExists(string $variableName, array $fields, $defaultValue): void
    {
        if (self::isNullable($variableName) && array_key_exists($variableName, $fields) && is_null($fields[$variableName])) {
            $this->openAPINullablesSetToNull[] = $variableName;
        }

        $this->container[$variableName] = $fields[$variableName] ?? $defaultValue;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets serviceLevelAgreement
     *
     * @return \SLIS\Adapter\Hub\Model\ServiceLevelAgreementReadFirewallRead|null
     */
    public function getServiceLevelAgreement()
    {
        return $this->container['serviceLevelAgreement'];
    }

    /**
     * Sets serviceLevelAgreement
     *
     * @param \SLIS\Adapter\Hub\Model\ServiceLevelAgreementReadFirewallRead|null $serviceLevelAgreement serviceLevelAgreement
     *
     * @return self
     */
    public function setServiceLevelAgreement($serviceLevelAgreement)
    {

        if (is_null($serviceLevelAgreement)) {
            throw new \InvalidArgumentException('non-nullable serviceLevelAgreement cannot be null');
        }

        $this->container['serviceLevelAgreement'] = $serviceLevelAgreement;

        return $this;
    }

    /**
     * Gets uuid
     *
     * @return string|null
     */
    public function getUuid()
    {
        return $this->container['uuid'];
    }

    /**
     * Sets uuid
     *
     * @param string|null $uuid uuid
     *
     * @return self
     */
    public function setUuid($uuid)
    {

        if (is_null($uuid)) {
            throw new \InvalidArgumentException('non-nullable uuid cannot be null');
        }

        $this->container['uuid'] = $uuid;

        return $this;
    }

    /**
     * Gets name
     *
     * @return string|null
     */
    public function getName()
    {
        return $this->container['name'];
    }

    /**
     * Sets name
     *
     * @param string|null $name name
     *
     * @return self
     */
    public function setName($name)
    {

        if (is_null($name)) {
            throw new \InvalidArgumentException('non-nullable name cannot be null');
        }

        $this->container['name'] = $name;

        return $this;
    }

    /**
     * Gets ip
     *
     * @return string|null
     */
    public function getIp()
    {
        return $this->container['ip'];
    }

    /**
     * Sets ip
     *
     * @param string|null $ip ip
     *
     * @return self
     */
    public function setIp($ip)
    {

        if (is_null($ip)) {
            array_push($this->openAPINullablesSetToNull, 'ip');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('ip', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['ip'] = $ip;

        return $this;
    }

    /**
     * Gets mac
     *
     * @return string|null
     */
    public function getMac()
    {
        return $this->container['mac'];
    }

    /**
     * Sets mac
     *
     * @param string|null $mac mac
     *
     * @return self
     */
    public function setMac($mac)
    {

        if (is_null($mac)) {
            array_push($this->openAPINullablesSetToNull, 'mac');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('mac', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['mac'] = $mac;

        return $this;
    }

    /**
     * Gets typ
     *
     * @return \SLIS\Adapter\Hub\Model\GeraetTypReadFirewallRead|null
     */
    public function getTyp()
    {
        return $this->container['typ'];
    }

    /**
     * Sets typ
     *
     * @param \SLIS\Adapter\Hub\Model\GeraetTypReadFirewallRead|null $typ typ
     *
     * @return self
     */
    public function setTyp($typ)
    {

        if (is_null($typ)) {
            throw new \InvalidArgumentException('non-nullable typ cannot be null');
        }

        $this->container['typ'] = $typ;

        return $this;
    }

    /**
     * Gets beschreibung
     *
     * @return string|null
     */
    public function getBeschreibung()
    {
        return $this->container['beschreibung'];
    }

    /**
     * Sets beschreibung
     *
     * @param string|null $beschreibung beschreibung
     *
     * @return self
     */
    public function setBeschreibung($beschreibung)
    {

        if (is_null($beschreibung)) {
            array_push($this->openAPINullablesSetToNull, 'beschreibung');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('beschreibung', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['beschreibung'] = $beschreibung;

        return $this;
    }

    /**
     * Gets seriennummer
     *
     * @return string|null
     */
    public function getSeriennummer()
    {
        return $this->container['seriennummer'];
    }

    /**
     * Sets seriennummer
     *
     * @param string|null $seriennummer seriennummer
     *
     * @return self
     */
    public function setSeriennummer($seriennummer)
    {

        if (is_null($seriennummer)) {
            array_push($this->openAPINullablesSetToNull, 'seriennummer');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('seriennummer', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['seriennummer'] = $seriennummer;

        return $this;
    }

    /**
     * Gets version
     *
     * @return string|null
     */
    public function getVersion()
    {
        return $this->container['version'];
    }

    /**
     * Sets version
     *
     * @param string|null $version version
     *
     * @return self
     */
    public function setVersion($version)
    {

        if (is_null($version)) {
            array_push($this->openAPINullablesSetToNull, 'version');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('version', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['version'] = $version;

        return $this;
    }

    /**
     * Gets externalIdentifier
     *
     * @return string|null
     */
    public function getExternalIdentifier()
    {
        return $this->container['externalIdentifier'];
    }

    /**
     * Sets externalIdentifier
     *
     * @param string|null $externalIdentifier externalIdentifier
     *
     * @return self
     */
    public function setExternalIdentifier($externalIdentifier)
    {

        if (is_null($externalIdentifier)) {
            array_push($this->openAPINullablesSetToNull, 'externalIdentifier');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('externalIdentifier', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['externalIdentifier'] = $externalIdentifier;

        return $this;
    }

    /**
     * Gets netzwerk
     *
     * @return \SLIS\Adapter\Hub\Model\FirewallReadFirewallReadNetzwerk|null
     */
    public function getNetzwerk()
    {
        return $this->container['netzwerk'];
    }

    /**
     * Sets netzwerk
     *
     * @param \SLIS\Adapter\Hub\Model\FirewallReadFirewallReadNetzwerk|null $netzwerk netzwerk
     *
     * @return self
     */
    public function setNetzwerk($netzwerk)
    {

        if (is_null($netzwerk)) {
            array_push($this->openAPINullablesSetToNull, 'netzwerk');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('netzwerk', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['netzwerk'] = $netzwerk;

        return $this;
    }

    /**
     * Gets hersteller
     *
     * @return \SLIS\Adapter\Hub\Model\FirewallReadFirewallReadHersteller|null
     */
    public function getHersteller()
    {
        return $this->container['hersteller'];
    }

    /**
     * Sets hersteller
     *
     * @param \SLIS\Adapter\Hub\Model\FirewallReadFirewallReadHersteller|null $hersteller hersteller
     *
     * @return self
     */
    public function setHersteller($hersteller)
    {

        if (is_null($hersteller)) {
            array_push($this->openAPINullablesSetToNull, 'hersteller');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('hersteller', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['hersteller'] = $hersteller;

        return $this;
    }

    /**
     * Gets tags
     *
     * @return \SLIS\Adapter\Hub\Model\TagReadFirewallRead[]|null
     */
    public function getTags()
    {
        return $this->container['tags'];
    }

    /**
     * Sets tags
     *
     * @param \SLIS\Adapter\Hub\Model\TagReadFirewallRead[]|null $tags tags
     *
     * @return self
     */
    public function setTags($tags)
    {

        if (is_null($tags)) {
            throw new \InvalidArgumentException('non-nullable tags cannot be null');
        }

        $this->container['tags'] = $tags;

        return $this;
    }

    /**
     * Gets status
     *
     * @return \SLIS\Adapter\Hub\Model\StatusReadFirewallRead|null
     */
    public function getStatus()
    {
        return $this->container['status'];
    }

    /**
     * Sets status
     *
     * @param \SLIS\Adapter\Hub\Model\StatusReadFirewallRead|null $status status
     *
     * @return self
     */
    public function setStatus($status)
    {

        if (is_null($status)) {
            throw new \InvalidArgumentException('non-nullable status cannot be null');
        }

        $this->container['status'] = $status;

        return $this;
    }

    /**
     * Gets created
     *
     * @return \DateTime|null
     */
    public function getCreated()
    {
        return $this->container['created'];
    }

    /**
     * Sets created
     *
     * @param \DateTime|null $created created
     *
     * @return self
     */
    public function setCreated($created)
    {

        if (is_null($created)) {
            array_push($this->openAPINullablesSetToNull, 'created');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('created', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['created'] = $created;

        return $this;
    }

    /**
     * Gets updated
     *
     * @return \DateTime|null
     */
    public function getUpdated()
    {
        return $this->container['updated'];
    }

    /**
     * Sets updated
     *
     * @param \DateTime|null $updated updated
     *
     * @return self
     */
    public function setUpdated($updated)
    {

        if (is_null($updated)) {
            array_push($this->openAPINullablesSetToNull, 'updated');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('updated', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['updated'] = $updated;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset): bool
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed|null
     */
    #[\ReturnTypeWillChange]
    public function offsetGet($offset)
    {
        return $this->container[$offset] ?? null;
    }

    /**
     * Sets value based on offset.
     *
     * @param int|null $offset Offset
     * @param mixed    $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value): void
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset): void
    {
        unset($this->container[$offset]);
    }

    /**
     * Serializes the object to a value that can be serialized natively by json_encode().
     * @link https://www.php.net/manual/en/jsonserializable.jsonserialize.php
     *
     * @return mixed Returns data which can be serialized by json_encode(), which is a value
     * of any type other than a resource.
     */
    #[\ReturnTypeWillChange]
    public function jsonSerialize()
    {
       return ObjectSerializer::sanitizeForSerialization($this);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


